#!/bin/sh

. ./build-env.sh

synofam=comcerto2k
if [ ! -e linux/arch/arm/configs/${BSP_CONFIG}_defconfig ]; then
  synofam=x64
fi

if [ -e build-env-${synofam}.sh ]; then
  echo "Using build-env-${synofam}.sh"
  . ./build-env-${synofam}.sh
fi

export ARCH=arm64
if [ "X${BSP_ARCH}" = "Xarmhf" ]; then
  export ARCH=arm
  export CROSS_COMPILE=arm-linux-gnueabihf-

elif [ "X${BSP_ARCH}" = "Xamd64" ]; then
  export ARCH=x86
  export CROSS_COMPILE=x86_64-linux-gnu-

elif [ "X${BSP_ARCH}" = "Xi686" ]; then
  export ARCH=x86
  export CROSS_COMPILE=i686-linux-gnu-

elif [ "X${BSP_ARCH}" = "Xpowerpc" ]; then
  export ARCH=powerpc
  export CROSS_COMPILE=powerpc-linux-gnu-
fi

export LOCALVERSION="+${BSP_MODEL}"

defcfg=${BSP_CONFIG}_defconfig
if [ "x$1" != "x" ] ; then
  defcfg=$1
fi

lxcfg=arch/${ARCH}/configs/${defcfg}


cd linux

cp -p .config config-saved

make LOCALVERSION="${LOCALVERSION}" ARCH=${ARCH} CROSS_COMPILE=${CROSS_COMPILE} mrproper clean

cd ..

echo OK
