#!bin/sh
synofam=88f628x

if [ ! -e linux-dsgpl-2.6.32.y -a ! -e linux-dsgpl-2.6.32.12-unpatched ]; then
  git clone -b mainline-2.6.32 https://github.com/scpcom/linux linux-dsgpl-2.6.32.y

  cd linux-dsgpl-2.6.32.y
  git fetch
  git pull origin
  git checkout mainline-2.6.32
  # Linux 2.6.32.12
  git checkout v2.6.32.12
  cd ..

  mv linux-dsgpl-2.6.32.y linux-dsgpl-2.6.32.12-unpatched
  #mkdir linux-dsgpl-2.6.32.12-unpatched
  #cp -apP linux-dsgpl-2.6.32.y/. linux-dsgpl-2.6.32.12-unpatched/
fi

if [ ! -e linux-dsgpl-2.6.32.y ]; then
  echo "Copying linux-dsgpl-2.6.32.12-unpatched ..."
  mkdir linux-dsgpl-2.6.32.y
  cp -apP linux-dsgpl-2.6.32.12-unpatched/. linux-dsgpl-2.6.32.y/

  cd linux-dsgpl-2.6.32.y

  git checkout v2.6.32.12
  git checkout -b mainline-2.6.32.12

  git checkout -b dsgpl-2.6.32.y-${synofam}

  #exit 1

  VERSION=`cat Makefile | grep -E '^VERSION.=' | cut -d "=" -f 2- | tr -d " \t\n\r"`
  PATCHLEVEL=`cat Makefile | grep PATCHLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`
  SUBVERSION=`cat Makefile | grep SUBLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`
  EXTRAVERSION=`cat Makefile | grep EXTRAVERSION.= | cut -d "=" -f 2- | tr -d " \t\n\r"`

  synoova=none
  synoovb=none
  synolva=mainline
  synolvb=1373
  #echo git tag -a ${VERSION}.${PATCHLEVEL}.${SUBVERSION}${EXTRAVERSION}-${synolvb}-${synofam} -m "dsgpl ${synolvb} branch ${synofam}"

  while read p; do
    #echo ${synolva}
    synoova=${synolva}
    synoovb=${synolvb}
    synolva=`echo $p | sed s/'\.patch$'/''/g | cut -d '-' -f 4`
    synolvb=`echo $p | sed s/'\.patch$'/''/g | cut -d '-' -f 6`

    if [ $synolva != $synoova -o $synolvb != $synoovb ]; then
      git tag -a ${VERSION}.${PATCHLEVEL}.${SUBVERSION}${EXTRAVERSION}-${synoovb}-${synofam} -m "dsgpl ${synoovb} branch ${synofam}"
      echo ""
    fi

    echo $p
    m=`echo $p | sed s/'\.patch$'/''/g | sed s/'-v.$'/''/g | cut -d '-' -f 7- | tr '-' ' '`
    if [ "X$m" = "X" ]; then
      m="changes"
    elif [ "X$m" = "Xextra" ]; then
      m="add/remove files"
    fi

    git apply ../patches/$p
    if [ "X$m" = "Xremove comments" ]; then
      w=`echo $p | cut -d '-' -f 1-6`-whitespace.patch
      git apply ../patches/$w
    fi
    rm -f include/linux/version.h
    git add .
    git commit -m "`echo $p | sed s/'\.patch$'/''/g | cut -d '-' -f 4-6`: $m"
  done <<<$(cat ../patches/series-${synofam} | grep patch | grep -v -E '^#')
  
  synoova=${synolva}
  synoovb=${synolvb}
  git tag -a ${VERSION}.${PATCHLEVEL}.${SUBVERSION}${EXTRAVERSION}-${synoovb}-${synofam} -m "dsgpl ${synoovb} branch ${synofam}"

  cd ..
fi

echo OK
